/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/console.c,v $
 * $Author: kawamoto $
 * $Revision: 1.3 $
 * $Date: 1994/04/23 11:35:36 $
 * $Log: console.c,v $
 *	Revision 1.3  1994/04/23  11:35:36  kawamoto
 *	hLgC
 *
 *	Revision 1.2  1993/10/24  18:32:53  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:38:38  kawamoto
 *	version 2.24 first cvs importing
 */

#include "dedit.h"
#include "console.h"

static void c_fnkmod (int shiftkey);

void PutHex(int x)
{
  x &= 15;
  B_PUTC((x < 10)? (x + '0') : (x + 'A' - 10));
}

void PrintDec(int i, int len)
{
  int j, flag, x;

  flag = 0;
  x = 1;
  for (j = 1; j < len; ++j)
    x *= 10;
  while (x > 1)
    {
      if ((j = i / x) != 0 || flag)
	{
	  flag = 1;
	  B_PUTC(j + '0');
	}
      else
	B_PUTC(' ');
      i %= x;
      x /= 10;
    }
  B_PUTC(i % 10 + '0');
}

char ShiftKey = 0;
char CtrlKey = 0;
char OPT1Key = 0;

void CheckShift()
{
  if (ShiftKey)
    {
      Post();
      exit(0);
    }
}

static uchar *macro = (uchar *)0;

static int GetNameSub(char *inBuf, int maxNum, int isPath)
{
  uchar flags[100];
  int offset, c, cu, end;
  struct NAMECKBUF nameBuf;

  offset = 0;
  end = maxNum ? maxNum : 21;
  macro = (uchar *)inBuf;
  while (1)
    {
      c = GetCon();
      if (c == 0x108 /* BS */)
	{
	  if (offset == 0)
	    goto error_next;
	  --offset;
	  B_PUTC(8);
	  B_PUTC(' ');
	  B_PUTC(8);
	  if (flags[offset] == 1)
	    continue;
	  if (offset == 0)
	    goto error_next;
	  --offset;
	  if (flags[offset+1] == 4)
	    continue;
	  B_PUTC(8);
	  B_PUTC(' ');
	  B_PUTC(8);
	  continue;
	}
      if (c == 0x11b /* ESC */)
	return ERROR;
      if (c == 0x10d /* CR */)
	{
	  if (offset == 0)
	    goto error_next;
	  inBuf[offset] = 0;
	  c = NAMECK(inBuf, &nameBuf);
	  if ((isPath && c == 0xff) || c == 0)
	    return 0;
	  goto error_next;
	}
      if (offset >= end)
	goto error_next;
      if ((c < 0x21) || (0x2A == c) || (0x3F == c) || (0x100 <= c))
	goto error_next;
      switch (c)
	{
	case 0x24:
	case 0x25:
	  if (!maxNum)
	    break;
	  goto error_next;
	case 0x3A:
	case 0x5C:
	  if (maxNum)
	    break;
	case 0x22:
	case 0x27:
	case 0x2F:
	case 0x5B:
	case 0x5D:
	case 0x7C:
	  goto error_next;
	}
      if ((0x80 <= c && c < 0xA0) || (0xE0 <= c && c < 0xF4))
	{
	  inBuf[offset] = cu = c;
	  flags[offset++] = 2;
	  while (1)
	    {
	      c = GetCon();
	      if (c >= 0x100)
		{
		  --offset;
		  goto error_next;
		}
	      if ((cu == 0x80) || (0xF0 <= cu && cu < 0xF4))
		{
		  flags[offset] = 4;
		  break;
		}
	      if (iskanji2(c))
		{
		  flags[offset] = 3;
		  break;
		}
	    }
	  if (offset >= end)
	    {
	      --offset;
	      goto error_next;
	    }
	  B_PUTC(cu);
	  B_PUTC(inBuf[offset++] = c);
	  continue;
	}
      B_PUTC(inBuf[offset] = c);
      flags[offset++] = 1;
      continue;
    error_next:
      B_PUTC(7);
    }
}
int GetName(char *inBuf, int maxNum, int isPath)
{
  int ret = GetNameSub(inBuf, maxNum, isPath);

  C_FNKMOD(ShiftKey);
  return ret;
}

static int GetStringSub(char *inBuf, int maxNum)
{
  uchar flags[100];
  int offset, c, cu;

  offset = 0;
  macro = (uchar *)inBuf;
  while (1)
    {
      c = GetCon();
      if (c == 0x108 /* BS */)
	{
	  if (offset == 0)
	    goto error_next;
	  --offset;
	  B_PUTC(8);
	  B_PUTC(' ');
	  B_PUTC(8);
	  if (flags[offset] == 1)
	    continue;
	  if (offset == 0)
	    goto error_next;
	  --offset;
	  if (flags[offset+1] == 4)
	    continue;
	  B_PUTC(8);
	  B_PUTC(' ');
	  B_PUTC(8);
	  continue;
	}
      if (c == 0x11b /* ESC */)
	return ERROR;
      if (c == 0x10d /* CR */)
	{
	  if (offset == 0)
	    goto error_next;
	  inBuf[offset] = 0;
	  return 0;
	}
      if (offset >= maxNum)
	goto error_next;
      if ((0x80 <= c && c < 0xA0) || (0xE0 <= c && c < 0xF4))
	{
	  inBuf[offset] = cu = c;
	  flags[offset++] = 2;
	  while (1)
	    {
	      c = GetCon();
	      if (c >= 0x100)
		{
		  --offset;
		  goto error_next;
		}
	      if ((cu == 0x80) || (0xF0 <= cu && cu < 0xF4))
		{
		  flags[offset] = 4;
		  break;
		}
	      if (iskanji2(c))
		{
		  flags[offset] = 3;
		  break;
		}
	    }
	  if (offset >= maxNum)
	    {
	      --offset;
	      goto error_next;
	    }
	  B_PUTC(cu);
	  B_PUTC(inBuf[offset++] = c);
	  continue;
	}
      if (c < 0x20)
	B_PUTC(0x80);
      B_PUTC(c);
      inBuf[offset] = c;
      flags[offset++] = 1;
      continue;
    error_next:
      B_PUTC(7);
    }
}
int GetString(char *inBuf, int maxNum)
{
  int ret = GetStringSub(inBuf, maxNum);

  C_FNKMOD(ShiftKey);
  return ret;
}

static int GetDateTimeSub(char *inBuf, int delimiter)
{
  int offset, c;

  offset = 0;
  while (1)
    {
      switch (c = GetCon())
	{
	case 0x108:/* BS */
	  if (offset == 0)
	    goto error_next;
	  --offset;
	  B_PUTC(8);
	  B_PUTC(' ');
	  B_PUTC(8);
	  continue;
	case 0x11b:/* ESC */
	  return ERROR;
	case 0x10d:/* CR */
	  if (offset < 8 && offset > 0)
	    goto error_next;
	  inBuf[offset] = 0;
	  return 0;
	case 'c':
	case 'l':
	case 'n':
	case 's':
	  inBuf[0] = toupper(c);
	  return 0;
	case 'C':
	case 'L':
	case 'N':
	case 'S':
	  inBuf[0] = c;
	  return 0;
	}
      switch (offset)
	{
	case 0:
	case 1:
	case 3:
	case 4:
	case 6:
	case 7:
	  if (c < '0' && c > '9')
	    goto error_next;
	  break;
	case 2:
	case 5:
	  if (c != delimiter)
	    goto error_next;
	  break;
	default:
	  goto error_next;
	}
      B_PUTC(inBuf[offset++] = c);
      continue;
    error_next:
      B_PUTC(7);
    }
}
int GetDateTime(char *inBuf, int delimiter)
{
  int ret = GetDateTimeSub(inBuf, delimiter);

  C_FNKMOD(ShiftKey);
  return ret;
}

int GetNum(int base, int max, int defNum)
{
  int c, val, count;

  val = 0;
  count = 0;
  while (1)
    {
      switch (c = GetKey())
	{
	case 0x0f:/* BS */
	  if (count == 0)
	    continue;
	  --count;
	  val /= base;
	  B_PUTC(8);
	  B_PUTC(' ');
	  B_PUTC(8);
	  continue;
	case 0x01:/* ESC */
	  return ERROR;
	case 0x1d:/* CR */
	case 0x4e:/* ENTER */
	  if (count)
	    return val;
	  PrintDec(defNum, max);
	  return defNum;
	case 0x4f:
	case 0x0b:
	  c = '0';
	  break;
	case 0x4b:
	case 0x02:
	  c = '1';
	  break;
	case 0x4c:
	case 0x03:
	  c = '2';
	  break;
	case 0x4d:
	case 0x04:
	  c = '3';
	  break;
	case 0x47:
	case 0x05:
	  c = '4';
	  break;
	case 0x48:
	case 0x06:
	  c = '5';
	  break;
	case 0x49:
	case 0x07:
	  c = '6';
	  break;
	case 0x43:
	case 0x08:
	  c = '7';
	  break;
	case 0x44:
	case 0x09:
	  c = '8';
	  break;
	case 0x45:
	case 0x0a:
	  c = '9';
	  break;
	case 0x3f:
	case 0x1e:
	  if (base != 16)
	    continue;
	  c = 'A';
	  break;
	case 0x40:
	case 0x2e:
	  if (base != 16)
	    continue;
	  c = 'B';
	  break;
	case 0x41:
	case 0x2c:
	  if (base != 16)
	    continue;
	  c = 'C';
	  break;
	case 0x42:
	case 0x20:
	  if (base != 16)
	    continue;
	  c = 'D';
	  break;
	case 0x46:
	case 0x13:
	  if (base != 16)
	    continue;
	  c = 'E';
	  break;
	case 0x4a:
	case 0x21:
	  if (base != 16)
	    continue;
	  c = 'F';
	  break;
	default:
	  continue;
	}
      if (count >= max)
	{
	  B_PUTC(7);
	  continue;
	}
      ++count;
      B_PUTC(c);
      c -= (c <= '9') ? '0' : 'A'-10;
      val *= base;
      val += c;
    }
}

#define KEYMACROMAX 100
static int keyMacroOffset = 0, keyMacroMax = 0, keyMacroNow = 0;
static unsigned short keyMacroBuf[KEYMACROMAX];
static char saveFile[80] = {0};

static void keyHELPsub()
{
  int i, len;

  while (1)
    {
      B_LOCATE(0, 29);
      B_ERA_AL();
      B_LOCATE(27, 29);
      B_PRINT("\33[36m}Nt@CɃZ[u܂iy/njH ");
      if (GetKey() != 0x16)
	return;
      len = keyMacroMax * sizeof(ushort);
      while (1)
	{
	  if ((i = FileSave(saveFile, (schar *)keyMacroBuf, len)) == 0)
	    break;
	  if (i == 1)
	    return;
	}
    }
}

struct FNTBUF2 {
  short x1;
  short y1;
  unsigned char buffer[96 * 16];
};

static void keyHELP()
{
  if (keyMacroNow == 1)
    {
      struct FNTBUF2 buf1, buf2;
      int csr = B_BPEEK ((void*) 0x992);

      keyMacroNow = 0;
      keyMacroMax = keyMacroOffset;
      keyMacroOffset = 0;
      B_PRINT("\33[s\33[1;76H\33[33m   ja lacro   ");
      B_CUROFF();
      buf2.x1 = 768;
      buf2.y1 = 16;
      TCOLOR(2);
      TEXTGET(0, 464, (struct FNTBUF *)&buf2);
      buf1.x1 = 768;
      buf1.y1 = 16;
      TCOLOR(1);
      TEXTGET(0, 464, (struct FNTBUF *)&buf1);
      keyHELPsub();
      B_CUROFF();
      TCOLOR(2);
      TEXTPUT(0, 464, (struct FNTBUF *)&buf2);
      TCOLOR(1);
      TEXTPUT(0, 464, (struct FNTBUF *)&buf1);
      B_PRINT("\33[u");
      if (!csr)
	B_CUROFF();
    }
  else
    {
      keyMacroNow = 1;
      B_PRINT("\33[s\33[1;76H\33[35m** ja lacro **\33[u");
    }
}

void MacroSave()
{
  if (keyMacroNow)
    keyHELP();
}

int MacroDef(char *fileName)
{
  int fp;

  if ((fp = OPEN(fileName, 2)) < 0)
    return 1;
  keyMacroMax = SEEK(fp, 0, 2) / sizeof(ushort);
  if (keyMacroMax > KEYMACROMAX)
    keyMacroMax = KEYMACROMAX;
  SEEK(fp, 0, 0);
  READ(fp, (uchar *)keyMacroBuf, keyMacroMax * sizeof(ushort));
  CLOSE(fp);
  keyMacroNow = 2;
  keyMacroOffset = 0;
  return 0;
}

static void keyUNDO()
{
  if (keyMacroNow || keyMacroMax == 0)
    B_PUTC(7);
  else
    {
      keyMacroNow = 2;
      keyMacroOffset = 0;
    }
}

static void enterToMacro(int c)
{
  if (keyMacroOffset == KEYMACROMAX)
    {
      B_PUTC(7);
      keyHELP();
    }
  else
    keyMacroBuf[keyMacroOffset++] = c;
}

static int GetConSub()
{
  int c;

keyMacroLoop:
  if (keyMacroNow == 2)
    {
      for ( ; keyMacroOffset < keyMacroMax; ++keyMacroOffset)
	if ((keyMacroBuf[keyMacroOffset] & 0xff00) == 0)
	  return keyMacroBuf[keyMacroOffset++];
      keyMacroNow = 0;
      keyMacroOffset = 0;
    }
  while (1)
    {
      while ((c = INPOUT(0xff)) == 0)
	{
	  c = B_SFTSNS();
	  if ((c & 1) != ShiftKey)
	    {
	      c = ShiftKey ? 0xfb : 0xfa;
	      break;
	    }
	  if ((c & 2) != CtrlKey)
	    {
	      c = CtrlKey ? 0xfd : 0xfc;
	      break;
	    }
	  if ((c & 4) != OPT1Key)
	    {
	      c = OPT1Key ? 0xff : 0xfe;
	      break;
	    }
	}
      switch (c)
	{
	case 0xf8:
	  keyHELP();
	  continue;
	case 0xf9:
	  keyUNDO();
	  goto keyMacroLoop;
	}
      if (keyMacroNow)
	enterToMacro(c);
      return c;
    }
}

int GetCon()
{
  int c;
static int last = 0;

  if (macro)
    {
      if (*macro == '\0')
	macro = (uchar *)0;
      else
	return *macro++;
    }
  while (1)
    {
      c = GetConSub();
      switch (c)
	{
	case 0xfa:
	  if (ShiftKey == 0)
	    c_fnkmod(ShiftKey = 1);
	  continue;
	case 0xfb:
	  if (ShiftKey)
	    c_fnkmod(ShiftKey = 0);
	  continue;
	case 0xfc:
	  CtrlKey = 2;
	  continue;
	case 0xfd:
	  CtrlKey = 0;
	  continue;
	case 0xfe:
	  OPT1Key = 4;
	  continue;
	case 0xff:
	  OPT1Key = 0;
	  continue;
	case 9:
	  if (last)
	    break;
	  last = 2;
	  continue;
	}
      switch (last)
	{
	case 0:
	  if (c < 0x20)
	    {
	      c |= 0x100;
	      break;
	    }
	  if ((0x80 <= c && c < 0xa0) || (0xe0 <= c))
	    last = 1;
	  break;
	case 1:
	  last = 0;
	  break;
	case 2:
	  c &= 0x1f;
	  last = 0;
	  break;
	}
      return c;
    }
}

static int GetIOCSsub()
{
  int c, c2;

keyMacroLoop:
  if (keyMacroNow == 2)
    {
      for ( ; keyMacroOffset < keyMacroMax; ++keyMacroOffset)
	if (keyMacroBuf[keyMacroOffset] & 0xff00)
	  return keyMacroBuf[keyMacroOffset++];
      keyMacroNow = 0;
      keyMacroOffset = 0;
    }
  while (1)
    {
      c = B_KEYINP();
      c2 = c >> 8;
      if (!(c2 & 0x80) && !(BITSNS(c2 >> 3) & (1 << (c2 & 7))))
	{
	  while ((B_KEYSNS() & 0xffff) == c)
	    B_KEYINP();
	  continue;
	}
      switch (c2)
	{
	case 0x54:
	  keyHELP();
	  continue;
	case 0x3a:
	  keyUNDO();
	  goto keyMacroLoop;
	case 0x70:
	  if (ShiftKey)
	    continue;
	  break;
	case 0x71:
	  if (CtrlKey)
	    continue;
	  break;
	case 0x72:
	  if (OPT1Key)
	    continue;
	  break;
	case 0x73:
	case 0xf3:
	  continue;
	}
      if (keyMacroNow)
	enterToMacro(c);
      return c;
    }
}

int GetIOCS()
{
  int c, c2;

  while (1)
    {
      c = GetIOCSsub();
      c2 = c >> 8;
      switch (c2)
	{
	case 0x70:
	  if (ShiftKey == 0)
	    c_fnkmod(ShiftKey = 1);
	  continue;
	case 0xf0:
	  if (ShiftKey)
	    c_fnkmod(ShiftKey = 0);
	  continue;
	case 0x71:
	  CtrlKey = 2;
	  continue;
	case 0xf1:
	  CtrlKey = 0;
	  continue;
	case 0x72:
	  OPT1Key = 4;
	  continue;
	case 0xf2:
	  OPT1Key = 0;
	  continue;
	case 0x73:
	case 0xf3:
	  continue;
	default:
	  if (c2 & 0x80)
	    continue;
	  return c;
	}
    }
}

static int NonWaitIOCSsub()
{
  int c, c2;

  while (1)
    {
      if (B_KEYSNS() == 0)
	return 0;
      c = B_KEYINP();
      c2 = c >> 8;
      if (!(c2 & 0x80) && !(BITSNS(c2 >> 3) & (1 << (c2 & 7))))
	{
	  while ((B_KEYSNS() & 0xffff) == c)
	    B_KEYINP();
	  continue;
	}
      switch (c2)
	{
	case 0x70:
	  if (ShiftKey)
	    continue;
	  break;
	case 0x71:
	  if (CtrlKey)
	    continue;
	  break;
	case 0x72:
	  if (OPT1Key)
	    continue;
	  break;
	case 0x73:
	case 0xf3:
	  continue;
	}
      return c;
    }
}

int NonWaitIOCS()
{
  int c, c2;

  while (1)
    {
      if ((c = NonWaitIOCSsub()) == 0)
	return 0;
      c2 = c >> 8;
      switch (c2)
	{
	case 0x70:
	  if (ShiftKey == 0)
	    c_fnkmod(ShiftKey = 1);
	  continue;
	case 0xf0:
	  if (ShiftKey)
	    c_fnkmod(ShiftKey = 0);
	  continue;
	case 0x71:
	  CtrlKey = 2;
	  continue;
	case 0xf1:
	  CtrlKey = 0;
	  continue;
	case 0x72:
	  OPT1Key = 4;
	  continue;
	case 0xf2:
	  OPT1Key = 0;
	  continue;
	case 0x73:
	case 0xf3:
	  continue;
	default:
	  if (c2 & 0x80)
	    continue;
	  return c;
	}
    }
}

static void
c_fnkmod (int shiftkey)
{
  register int reg_d0 __asm ("d0");

  __asm __volatile ("pea    (8)\n\t"
		    "DOS    $ff22\n\t"		/* _KNJCTRL */
		    "move.l d0,(sp)\n\t"
		    "pea    (7)\n\t"
		    "DOS    $ff22\n\t"		/* _KNJCTRL */
		    "addq.l #8,sp"
			: "=d" (reg_d0));
  if (reg_d0)
    return;

  C_FNKMOD(shiftkey);
}

/* EOF */
