/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/dir.c,v $
 * $Author: kawamoto $
 * $Revision: 1.2 $
 * $Date: 1993/10/24 18:34:08 $
 * $Log: dir.c,v $
 *	Revision 1.2  1993/10/24  18:34:08  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:39:46  kawamoto
 *	version 2.24 first cvs importing
 */

#include "dedit.h"
#include "console.h"
#include "error.h"
#include "dir.h"

char distinct = 1, number = 0, target = 2, killedSelect;
int markFlag;

int fatNo;
uchar temp[100];
uchar *dirPtr, *fatPtr;
uchar *topDir, *adrDir, *endDir;
uchar *markTop, *markEnd;
int lower;
int curY, lCurY;
int locX, locY;
int sizeDir;

direntry *dir(int (*funcKeys)(), int select)
{
  direntry *wPtr;
  int d, offset;
  uchar c;

  fatNo = ToParent(&offset);
  sizeDir = DPBbuf.fatlen;
  if (diskred(0, fatPtr, CurDrive, DPBbuf.fatsec, sizeDir))
    return (direntry *)ERROR;
  markTop = markEnd = (uchar *)-1;
  markFlag = 0;
  (*funcKeys)(FUNC_PRE);
  if (fatNo == ERROR)
    offset = jumpToCurPath();
  readDirec(1);
  henkouDir = 0;
  wPtr = (direntry *)dirPtr + offset;
  adrDir = (uchar *)wPtr - 320;
  if (adrDir < topDir)
    adrDir = topDir;
  if (adrDir > endDir)
    adrDir = endDir;
  curY = wPtr - (direntry *)adrDir;
  locY = curY + 6;
  dDump();
  B_LOCATE(0, 4);
  B_COLOR(3);
  PrintPath();
  B_LOCATE(locX, locY);
  B_CURON();
  CurXor(locX, locY, 0);
  while (1)
    {
      switch (c = GetKey())
	{
	case 0x3e:/* DOWN */
	  if (markFlag != 2)
	    CurXor(locX, locY, 0);
	  ++curY;
	  if (lower >= 0 && curY >= lower)
	    {
	      --curY;
	      break;
	    }
	  if (curY <= 19)
	    {
	      locY++;
	      break;
	    }
	  --curY;
	  adrDir += 32;
	  if (adrDir > endDir)
	    adrDir = endDir;
	  else
	    {
	      Scroll(6, 25, 1, 8);
	      dDump2(19);
	    }
	  break;
	case 0x38:/* ROLL UP */
	  if (markFlag != 2)
	    CurXor(locX, locY, 0);
	  adrDir += 20 << 5;
	  if (adrDir > endDir)
	    {
	      curY += (adrDir - endDir) >> 5;
	      adrDir = endDir;
	    }
	  if (adrDir == endDir)
	    {
	      int newCurY;
	      newCurY = (lower >= 0) ? lower - 1 : 19;
	      if (curY > newCurY)
		curY = newCurY;
	    }
	  locY = curY + 6;
	  if (markFlag == 1)
	    {
	      markEnd = adrDir + (curY << 5);
	      if (markEnd < markTop)
		funcTOP();
	    }
	  dDump();
	  break;
	case 0x3c:/* UP */
	  if (markFlag != 2)
	    CurXor(locX, locY, 0);
	  if (--curY >= 0)
	    {
	      locY--;
	      break;
	    }
	  ++curY;
	  adrDir -= 32;
	  if (adrDir < topDir)
	    {
	      adrDir = topDir;
	      if (markFlag == 2 && curY == 0)
		{
		  curY = -1;
		  locY = 5;
		}
	    }
	  else
	    {
	      Scroll(6, 25, -1, 8);
	      dDump2(0);
	    }
	  break;
	case 0x39:/* ROLL DOWN */
	  if (markFlag != 2)
	    CurXor(locX, locY, 0);
	  if (adrDir == topDir)
	    {
	      if (markFlag == 2 && curY <= 0)
		{
		  curY = -1;
		  locY = 5;
		}
	      else
		{
		  curY = 0;
		  locY = 6;
		}
	      break;
	    }
	  adrDir -= 20 << 5;
	  if (adrDir < topDir)
	    {
	      curY -= (topDir - adrDir) >> 5;
	      adrDir = topDir;
	    }
	  if (adrDir == topDir)
	    if (curY < -1)
	      curY = -1;
	  locY = curY + 6;
	  if (markFlag == 1)
	    {
	      markEnd = adrDir + (curY << 5);
	      if (markEnd < markTop)
		funcTOP();
	    }
	  dDump();
	  break;
	case 0x1d:/* CR */
	case 0x4e:/* ENTER */
	  if (markFlag != 2)
	    CurXor(locX, locY, 0);
	  d = ((adrDir - dirPtr) >> 5)+ curY;
	  wPtr = (direntry *)dirPtr + d;
	  if (wPtr->fileName[0] == (char)0xe5)
	    {
	      if (killedSelect == 0)
		break;
	      if ((killedSelect == 1) && (wPtr->atr & 0x10))
		break;
	    }
	  if ((wPtr->fatNo[1] == 0) && (wPtr->fatNo[0] < 2))
	    break;
	  if (toCHILD())
	    break;
	  if (!select)
	    break;
	  ToChild(wPtr, d, 1);
	  return wPtr;
	case 0x63:/* F1 */
	case 0x64:/* F2 */
	case 0x65:/* F3 */
	case 0x66:/* F4 */
	case 0x67:/* F5 */
	case 0x68:/* F6 */
	case 0x69:/* F7 */
	case 0x6A:/* F8 */
	case 0x6B:/* F9 */
	case 0x6C:/* F10 */
	  if (markFlag != 2)
	    CurXor(locX, locY, 0);
	  if ((*funcKeys)(ShiftKey ? (c - 0x62 + 10) : (c - 0x62)) == 0)
	    break;
	  d = ((adrDir - dirPtr) >> 5) + curY;
	  wPtr = (direntry *)dirPtr + d;
	  if (!killedSelect && (wPtr->fileName[0] == (char)0xe5))
	    break;
	  if ((wPtr->fatNo[1] == 0) && (wPtr->fatNo[0] < 2))
	    break;
	  ToChild(wPtr, d, 1);
	  return wPtr;
	case 0x0F:/* BS */
	  if (markFlag != 2)
	    CurXor(locX, locY, 0);
	  if (checkHenkouDir(HenDIR))
	    break;
	  toPAREN();
	  break;
	case 0x01:/* ESC */
	  c = ShiftKey;
	  if (checkHenkouDir(c ? HenEND : HenDIR))
	    break;
	  if (c)
	    {
	      Post();
	      exit(0);
	    }
	  if (markFlag != 2)
	    CurXor(locX, locY, 0);
	  if (toPAREN())
	    break;
	  return (direntry *)ERROR;
	default:
	  continue;
	}
      switch (markFlag)
	{
	case 2:
	  underoff();
	  underon();
	  continue;
	case 1:
	  if (adrDir + (curY << 5) > markEnd)
	    rev(curY, curY);
	  else if ((adrDir + (curY << 5) < markEnd) && curY < 19)
	    rev(curY + 1, curY + 1);
	  markEnd = adrDir + (curY << 5);
	  if (markEnd < markTop)
	    funcTOP();
	case 0:
	  B_LOCATE(locX, locY);
	  CurXor(locX, locY, 0);
	}
    }
}
