/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/dirsort.c,v $
 * $Author: kawamoto $
 * $Revision: 1.2 $
 * $Date: 1993/10/24 18:34:50 $
 * $Log: dirsort.c,v $
 *	Revision 1.2  1993/10/24  18:34:50  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:40:23  kawamoto
 *	version 2.24 first cvs importing
 */

#include "dedit.h"
#include "dir.h"

/* sort addition 90/02/02 */

/*                   */
/* sort sub routines */
/* addition 90/02/02 */
/* sortdate 92/02/29 */
/*                   */

static void setHTopEnd(direntry **, direntry **);
static void tsumeru(void);
static void sort(int (*)());
static void sort_body(direntry *, direntry *, int (*)());
static int compSortASCIIsub(uchar *, uchar *, int);
static int compSortASCII(direntry *, direntry *);
static int compSortVDA(direntry *, direntry *);
static int compSortVAD(direntry *, direntry *);
static int compSortDate(direntry *, direntry *);

static void setHTopEnd(direntry **hTopPtr, direntry **hEndPtr)
{
  if (markFlag)
    {
      *hTopPtr = (direntry *)markTop;
      *hEndPtr = (direntry *)markEnd + 1;
    }
  else
    {
      *hTopPtr = (direntry *)topDir;
      *hEndPtr = (direntry *)endDir;
      if (lower >= 0)
	*hEndPtr += lower;
      else
	*hEndPtr += 20;
    }
  while (*hTopPtr < *hEndPtr && (uchar)(*hEndPtr)[-1].fileName[0] == 0xe5)
    --*hEndPtr;
}

static void tsumeru()
{
  direntry *hTopDir, *hEndDir, *hPtr;
  direntry work;

  henkouDir = 1;
  setHTopEnd(&hTopDir, &hEndDir);
  for (hPtr = hEndDir - 1; hTopDir <= hPtr; --hPtr)
    {
      if ((uchar)hPtr->fileName[0] != 0xe5)
	continue;
      if (hEndDir > hPtr + 1)
	{
	  work = *hPtr;
	  movmem((char *)(hPtr + 1), (char *)hPtr, (char *)hEndDir - (char *)(hPtr + 1));
	  hEndDir[-1] = work;
	}
      --hEndDir;
    }
}

void funcTSUMERU()
{
  tsumeru();
  dDump();
}

void funcReverse()
{
  direntry *hTopDir, *hEndDir;
  direntry work;

  tsumeru();
  setHTopEnd(&hTopDir, &hEndDir);
  while (hTopDir < --hEndDir)
    {
      work = *hTopDir;
      *hTopDir = *hEndDir;
      *hEndDir = work;
      ++hTopDir;
    }
  dDump();
}

void sort(int (*comp)())
{
  direntry *hTopDir, *hEndDir;

  tsumeru();
  setHTopEnd(&hTopDir, &hEndDir);
  sort_body(hTopDir, hEndDir, comp);
  dDump();
}

static void sort_body(direntry *hTopDir, direntry *hEndDir, int (*comp)())
{
  direntry *hTar, *hPtr;
  direntry work;

  for ( ; hTopDir < hEndDir; ++hTopDir)
    {
      hTar = hTopDir;
      for (hPtr = hTar + 1; hPtr < hEndDir; ++hPtr)
	if ((*comp)(hTar, hPtr) > 0)
	  hTar = hPtr;
      work = *hTar;
      for (hPtr = hTar - 1; hPtr >= hTopDir; --hPtr)
	hPtr[1] = hPtr[0];
      *hTopDir = work;
    }
}

static int compSortASCIIsub(uchar *ptr1, uchar *ptr2, int num)
{
  int i, j;
  int ch1, ch2, dig1, dig2;

  if ((ch1 = ptr1[0]) == 0x05)
    ch1 = 0xe5;
  if ((ch2 = ptr2[0]) == 0x05)
    ch2 = 0xe5;
  for (i = 0; i < num; ch1 = ptr1[++i], ch2 = ptr2[i])
    {
      if (!distinct)
	{
	  ch1 = toupper(ch1);
	  ch2 = toupper(ch2);
	}
      if (number && isdigit(ch1) && isdigit(ch2))
	{
	  j = i;
	  dig1 = 0;
	  while (i < num && isdigit(ch1))
	    {
	      dig1 *= 10;
	      dig1 += ch1 - '0';
	      ch1 = ptr1[++i];
	    }
	  i = j;
	  dig2 = 0;
	  while (i < num && isdigit(ch2))
	    {
	      dig2 *= 10;
	      dig2 += ch2 - '0';
	      ch2 = ptr2[++i];
	    }
	  if (dig1 != dig2)
	    return dig1 - dig2;
	  i = j;
	  ch1 = ptr1[i];
	  ch2 = ptr2[i];
	}
      if (ch1 != ch2)
	return ch1 - ch2;
    }
  return 0;
}

static int compSortASCII(direntry *ptr1, direntry *ptr2)
{
  int ret;

  if (target != 1)
    {
      ret = compSortASCIIsub((uchar *)ptr1->fileName, (uchar *)ptr2->fileName, 8);
      if (ret)
	return ret;
      ret = compSortASCIIsub((uchar *)ptr1->fileName2, (uchar *)ptr2->fileName2, 10);
      if (ret)
	return ret;
    }
  ret = 0;
  if (target != 0)
    ret = compSortASCIIsub((uchar *)ptr1->ext, (uchar *)ptr2->ext, 3);
  return ret;
}

void funcSortASCII()
{
  sort(compSortASCII);
}

static int compSortVDA(direntry *ptr1, direntry *ptr2)
{
  return (ptr1->atr & 0x38) - (ptr2->atr & 0x38);
}

void funcSortVDA()
{
  sort(compSortVDA);
}

static int compSortVAD(direntry *ptr1, direntry *ptr2)
{
  int atr1, atr2;

  atr1 = ptr1->atr & 0x38;
  if (atr1 == 0x10)
    atr1 = 0x40;
  atr2 = ptr2->atr & 0x38;
  if (atr2 == 0x10)
    atr2 = 0x40;
  return atr1 - atr2;
}

void funcSortVAD()
{
  sort(compSortVAD);
}

static int compSortDate(direntry *ptr1, direntry *ptr2)
{
  if (ptr1->date[1] != ptr2->date[1])
    return ptr1->date[1] - ptr2->date[1];
  if (ptr1->date[0] != ptr2->date[0])
    return ptr1->date[0] - ptr2->date[0];
  if (ptr1->time[1] != ptr2->time[1])
    return ptr1->time[1] - ptr2->time[1];
  return ptr1->time[0] - ptr2->time[0];
}

void funcSortDate()
{
  sort(compSortDate);
}

void funcDistinct()
{
  if (distinct)
    distinct = 0;
  else
    distinct = 1;
  setDistinct();
}

void setDistinct()
{
  if (distinct)
    FNCKEYST(12, "* Aa ");
  else
    FNCKEYST(12, "* Aa ");
}

void funcSortNum()
{
  if (number)
    number = 0;
  else
    number = 1;
  setSortNum();
}

void setSortNum()
{
  if (number)
    FNCKEYST(13, "*  l");
  else
    FNCKEYST(13, "* L ");
}

void funcSortTarget()
{
  switch (target)
    {
    case 0:
      target = 1;
      break;
    case 1:
      target = 2;
      break;
    case 2:
      target = 0;
      break;
    }
  setSortTarget();
}

void setSortTarget()
{
  switch (target)
    {
    case 0:
      FNCKEYST(14, "* m[h");
      break;
    case 1:
      FNCKEYST(14, "* gq");
      break;
    case 2:
      FNCKEYST(14, "* S ");
      break;
    }
}
