/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/editfile.c,v $
 * $Author: kawamoto $
 * $Revision: 1.2 $
 * $Date: 1993/10/24 18:35:52 $
 * $Log: editfile.c,v $
 *	Revision 1.2  1993/10/24  18:35:52  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:41:19  kawamoto
 *	version 2.24 first cvs importing
 */

#include "dedit.h"
#include "console.h"
#include "error.h"
#include "search.h"
#include "edit.h"

static int fOffset, fSize, fLength;
static uchar *fatPtr;
static int *fileTable;
static int funcFile(int);

void FileEdit(direntry *wPtr)
{
  int fat, fatWork, i;

  if (wPtr->atr & 8)
    return;
  if (wPtr->atr & 16)
    fLength = -1;
  else
    {
      fLength = wPtr->fileLen[3];
      fLength <<= 8;
      fLength += wPtr->fileLen[2];
      fLength <<= 8;
      fLength += wPtr->fileLen[1];
      fLength <<= 8;
      fLength += wPtr->fileLen[0];
    }
  fat = (wPtr->fatNo[1] << 8) + (wPtr->fatNo[0]);
  fSize = DPBbuf.fatlen;
  fatPtr = Malloc(fSize * DPBbuf.byte);
  B_CUROFF();
  if (diskred(0, (uchar *)fatPtr, CurDrive, DPBbuf.fatsec, fSize))
    return;
  fSize = 0;
  fatWork = fat;
  while (FATnoOk(fatPtr, fatWork))
    {
      ++fSize;
      fatWork = NextFATNo(fatPtr, fatWork);
    }
  fileTable = (int *)Malloc(fSize * 4);
  fatWork = fat;
  i = 0;
  while (FATnoOk(fatPtr, fatWork))
    {
      fileTable[i++] = fatWork;
      fatWork = NextFATNo(fatPtr, fatWork);
    }
  free(fatPtr);
  fOffset = 0;
  cluster = fileTable[fOffset];
  ptr = Malloc(DPBbuf.byte << DPBbuf.shift);
  edit((int)ptr, DPBbuf.byte << DPBbuf.shift, 0, funcFile);
  free(ptr);
  free(fileTable);
}

static int funcFile(int keyNo)
{
  switch (keyNo)
    {
    case FUNC_PRE:
      B_LOCATE(35, 3);
      B_PRINT("\33[36m[[[ \33[35m@ \33[36m]]]");
      B_LOCATE(0, 4);
      B_COLOR(7);
      PrintPath();
      if (fLength == -1)
	{
	  B_LOCATE(28, 5);
	  B_PRINT("\33[31mfBNg      NX^ mD\33[33m");
	  B_LOCATE(33, 5);
	}
      else
	{
	  B_LOCATE(28, 5);
	  B_PRINT("\33[31m              NX^ mD\33[33m");
	  B_LOCATE(33, 5);
	  B_COLOR(7);
	  B_PUTC('$');
	  for (keyNo = 28; keyNo >= 0; keyNo -= 4)
	    PutHex(fLength >> keyNo);
	}
      B_CUROFF();
      FNCKEYST(2, MesFKeyReadC);
      FNCKEYST(3, MesFKeyWriteC);
      FNCKEYST(8, MesFKeyAdrsC);
      FNCKEYST(9, MesFKeyNxtSctrC);
      FNCKEYST(10, MesFKeyLstSctrC);
      FNCKEYST(12, MesFKeyLoadC);
      FNCKEYST(13, MesFKeySaveC);
      FNCKEYST(19, MesFKeyHdSctrC);
      return dClusterRead(ptr);
    case 2:
      if (checkHenkouEdit(HenREAD))
	return FUNC_ERROR;
      keyNo = fOffset;
      break;
    case 3:
      B_LOCATE(22, 29);
      B_PRINT(MesWriteOKQ);
      keyNo = GetKey();
      B_LOCATE(0, 29);
      B_ERA_AL();
      if (keyNo == 0x16)
	if (!diskwrt(0, ptr, CurDrive, FATnoToSector(cluster), DPBbuf.sec + 1))
	  henkouEdit = 0;
      return FUNC_NORMAL;
    case 8:
      if (checkHenkouEdit(HenADDR))
	return FUNC_ERROR;
      B_LOCATE(40, 29);
      B_PRINT("\33[37mAhX H $");
      keyNo = GetNum(16, 8, 0);
      B_LOCATE(0, 29);
      B_ERA_AL();
      if (keyNo == ERROR)
	return FUNC_NORMAL;
      if (fLength <= keyNo)
	keyNo = fLength - 1;
      fOffset = keyNo / sizeEdit;
      cluster = fileTable[fOffset];
      keyNo -= fOffset * sizeEdit;
      adrEdit = keyNo;
      adrEdit &= 0xfffffff0;
      adrEdit += topEdit - 16 * 8;
      keyNo += topEdit;
      if (adrEdit < topEdit)
	adrEdit = topEdit;
      if (adrEdit >= endEdit)
	adrEdit = endEdit;
      offset = fOffset * sizeEdit;
      base = topEdit - offset;
      if (dClusterRead(ptr))
	{
	  Post();
	  exit(0);
	}
      Dump(adrEdit, base);
      return keyNo - adrEdit;
    case 9:
      keyNo = fOffset + 1;
      break;
    case 10:
      keyNo = fOffset - 1;
      break;
    case 12:
      funcLOAD();
      return FUNC_NORMAL;
    case 13:
      funcSAVE();
      return FUNC_NORMAL;
    case 19:
      keyNo = 0;
      break;
    case 29:
      keyNo = fOffset + 1;
      if (keyNo > fSize - 1)
	return FUNC_ERROR;
      break;
    case 30:
      keyNo = fOffset - 1;
      if (keyNo < 0)
	return FUNC_ERROR;
      break;
    default:
      return FUNC_NORMAL;
    }
  if (keyNo < 0)
    keyNo = fSize - 1;
  if (keyNo > fSize - 1)
    keyNo = 0;
  if (checkHenkouEdit(HenSECTOR))
    return FUNC_ERROR;
  fOffset = keyNo;
  cluster = fileTable[fOffset];
  offset = fOffset * sizeEdit;
  base = topEdit - offset;
  if (dClusterRead(ptr))
    {
      Post();
      exit(0);
    }
  Dump(adrEdit, base);
  return FUNC_NORMAL;
}
