/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/edithdsector.c,v $
 * $Author: kawamoto $
 * $Revision: 1.3 $
 * $Date: 1995/05/08 01:03:59 $
 * $Log: edithdsector.c,v $
 *	Revision 1.3  1995/05/08  01:03:59  kawamoto
 *	Version 2.26b
 *
 *	Revision 1.2  1993/10/24  18:36:00  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:41:26  kawamoto
 *	version 2.24 first cvs importing
 */

#include "dedit.h"
#include "console.h"
#include "error.h"
#include "search.h"
#include "edit.h"

static int isSCSI;
static int SCSIid, SCSIblockSize, SCSIblockFactor;
static int souchiNo, pda;
static int funcHDsect(int);

/* SCSI @̍ő僆jbg(0=SCSIȂ 8=SCSI 16=TwoSCSI) */
int SCSIunitMax;

void HDsectorEdit()
{
  isSCSI = 0;
  B_LOCATE(43, 25);
  B_PRINT(MesSouchiNoQ);
  B_LOCATE(54, 25);
  souchiNo = GetNum(10, 2, 0);
  if (souchiNo < 0 || souchiNo >= B_BPEEK((uchar *)0xED005A))
    return;
  ptr = Malloc(256);
  pda = souchiNo << 8;
  pda |= 0x8000;
  sector = 0;
  B_CUROFF();
  if (B_READ(pda, 4, 256, ptr) >= 0)
    maxSector = ((int *)ptr)[1] - 1;
  else
    maxSector = 0x7fffffff;
  edit((int)ptr, 256, 0, funcHDsect);
  free(ptr);
}

#define SCSI_DIRECT 0
#define SCSI_READONLY 5
#define SCSI_OPTICAL 7

void SCSIblockEdit()
{
  struct _inquiry inq;
  struct _readcap cap;

  if (SCSIunitMax == 0)
    return;

  isSCSI = 1;
  B_LOCATE(40, 25);
  B_PRINT(MesSCSIidQ);
  B_LOCATE(56, 25);
  SCSIid = GetNum(SCSIunitMax > 8 ? 16 : 10, 1, 0);
  if (SCSIid < 0 || SCSIunitMax <= SCSIid)
    return;
  if (SCSIid == (B_BPEEK((uchar *)0xED0070) & 7))
    return;
  if (_scsi_testunit (SCSIid)
   || _scsi_testunit (B_BPEEK ((uchar*) 0xed0070) & 7) != -1)
    return;
  if (_scsi_inquiry (sizeof (inq.unit), SCSIid, &inq))
    return;
  if (inq.unit != 0x84
   && inq.unit != SCSI_DIRECT
   && inq.unit != SCSI_READONLY
   && inq.unit != SCSI_OPTICAL)
    return;
  if (_scsi_readcap (SCSIid, &cap))
    return;
  SCSIblockSize = cap.size;
#if 0
  if (SCSIblockSize > 1024)
    return;
  SCSIblockFactor = SCSIblockSize >> 9;
#else
  switch (SCSIblockSize)
    {
    case 512:
      SCSIblockFactor = 1;
      break;
    case 1024:
      SCSIblockFactor = 2;
      break;
    case 2048:
      SCSIblockFactor = 3;
      break;
    default:
      SCSIblockFactor = 1;
      break;
    }
#endif
  maxSector = cap.block;
  sector = 0;
  B_CUROFF();
#if 0
  ptr = Malloc(1024);
#else
  ptr = Malloc(2048);
#endif
  edit((int)ptr, SCSIblockSize, 0, funcHDsect);
  free(ptr);
}

static int funcHDsect(int keyNo)
{
  int i;

  switch (keyNo)
    {
    case FUNC_PRE:
      if (isSCSI)
	{
	  B_LOCATE(22, 3);
	  B_PRINT("\33[36m[[[ \33[35mrbrh@@@ \33[36m]]]");
	  B_LOCATE(29, 5);
	  B_PRINT("\33[31mSCSI ID         ubN mD\33[33m");
	  B_LOCATE(38, 5);
	  B_COLOR(7);
	  B_PUTC(SCSIid >= 10 ? (SCSIid - 10 + 'A') : (SCSIid + '0'));
	}
      else
	{
	  B_LOCATE(23, 3);
	  B_PRINT("\33[36m[[[ \33[35m@@@ \33[36m]]]");
	  B_LOCATE(29, 5);
	  B_PRINT("\33[31muԍ        ZN^[ mD\33[33m");
	  B_LOCATE(39, 5);
	  B_COLOR(7);
	  B_PUTC((souchiNo >= 10) ? '1' : ' ');
	  B_PUTC((souchiNo >= 10) ? souchiNo + ('0' - 10) : souchiNo + '0');
	}
      B_LOCATE(60, 5);
      B_PUTC('$');
      for (keyNo = 28; keyNo >= 0; keyNo -= 4)
	PutHex(sector >> keyNo);
      B_CUROFF();
      if (!isSCSI)
	FNCKEYST(1, "\xfe@u \x11");
      FNCKEYST(2, MesFKeyReadC);
      FNCKEYST(3, MesFKeyWriteC);
      FNCKEYST(9, MesFKeyNxtSctrC);
      FNCKEYST(10, MesFKeyLstSctrC);
      FNCKEYST(12, MesFKeyLoadC);
      FNCKEYST(13, MesFKeySaveC);
      FNCKEYST(19, MesFKeyHdSctrC);
      FNCKEYST(20, MesFKeySctrNoC);
      if (isSCSI)
	{
	  while (1)
	    {
	      int rc = _scsi_readext (sector, 1, SCSIid, SCSIblockFactor, ptr);

	      if (rc != -1 && rc != -2)
		break;
	      switch (ErrorHandle(29))
		{
		case 1:
		  return FUNC_ERROR;
		case 2:
		  continue;
		}
	      break;
	    }
	}
      else
	{
	  while (B_READ(pda, sector, 256, ptr) < 0)
	    {
	      switch (ErrorHandle(29))
		{
		case 1:
		  return 1;
		case 2:
		  continue;
		}
	      break;
	    }
	}
      return 0;
    case 1:
      if (isSCSI)
	return FUNC_NORMAL;
      if (checkHenkouEdit(HenSOUCHI))
	return FUNC_ERROR;
      B_LOCATE(43, 29);
      B_PRINT(MesSouchiNoQ);
      B_LOCATE(54, 29);
      souchiNo = GetNum(10, 2, 0);
      B_ERA_AL();
      B_CUROFF();
      if (souchiNo < 0 || souchiNo >= B_BPEEK((uchar *)0xED005A))
	return FUNC_NORMAL;
      keyNo = souchiNo << 8;
      keyNo |= 0x8000;
      if (B_READ(keyNo, 4, 256, ptr) < 0)
	return FUNC_NORMAL;
      pda = keyNo;
      keyNo = 0;
      maxSector = ((int *)ptr)[1] - 1;
      B_LOCATE(38, 5);
      B_COLOR(7);
      B_PUTC((souchiNo >= 10) ? '1' : ' ');
      B_PUTC((souchiNo >= 10) ? souchiNo + ('0' - 10) : souchiNo + '0');
      break;
    case 2:
      if (checkHenkouEdit(HenREAD))
	return FUNC_ERROR;
      keyNo = sector;
      break;
    case 3:
      B_LOCATE(22, 29);
      B_PRINT(MesWriteOKQ);
      keyNo = GetKey();
      B_LOCATE(0, 29);
      B_ERA_AL();
      if (keyNo == 0x16)
	{
	  if (isSCSI)
	    {
	      while (1)
		{
		  int rc = _scsi_writeext (sector, 1, SCSIid, SCSIblockFactor, ptr);

		  if (rc != -1 && rc != -2)
		    break;
		  switch (ErrorHandle(29))
		    {
		    case 1:
		      return FUNC_ERROR;
		    case 2:
		      continue;
		    }
		  break;
		}
	    }
	  else
	    {
	      while (B_WRITE(pda, sector, 256, ptr) < 0)
		{
		  switch (ErrorHandle(29))
		    {
		    case 1:
		      return FUNC_ERROR;
		    case 2:
		      continue;
		    }
		  break;
		}
	    }
	  henkouEdit = 0;
	}
      return FUNC_NORMAL;
    case 9:
      keyNo = sector + 1;
      break;
    case 10:
      keyNo = sector - 1;
      break;
    case 12:
      funcLOAD();
      return FUNC_NORMAL;
    case 13:
      funcSAVE();
      return FUNC_NORMAL;
    case 19:
      keyNo = 0;
      break;
    case 20:
      B_LOCATE(40, 29);
      B_PRINT("\33[37mZN^[ m $");
      keyNo = GetNum(16, 8, sector);
      B_LOCATE(0, 29);
      B_ERA_AL();
      if (keyNo == ERROR)
	return FUNC_NORMAL;
      if (keyNo > maxSector)
	keyNo = maxSector;
      break;
    case 29:
      keyNo = sector + 1;
      if (keyNo > maxSector)
	return FUNC_ERROR;
      break;
    case 30:
      keyNo = sector - 1;
      if (keyNo < 0)
	return FUNC_ERROR;
      break;
    default:
      return FUNC_NORMAL;
    }
  if (keyNo < 0)
    keyNo = maxSector;
  if (keyNo > maxSector)
    keyNo = 0;
  if (checkHenkouEdit(HenSECTOR))
    return FUNC_ERROR;
  if (isSCSI)
    {
      while (1)
	{
	  int rc = _scsi_readext (keyNo, 1, SCSIid, SCSIblockFactor, ptr);

	  if (rc != -1 && rc != -2)
	    break;
	  switch (ErrorHandle(29))
	    {
	    case 1:
	      return FUNC_ERROR;
	    case 2:
	      continue;
	    }
	  break;
	}
    }
  else
    {
      while (B_READ(pda, keyNo, 256, ptr) < 0)
	{
	  switch (ErrorHandle(29))
	    {
	    case 1:
	      return FUNC_ERROR;
	    case 2:
	      continue;
	    }
	  break;
	}
    }
  sector = keyNo;
  B_LOCATE(60, 5);
  B_COLOR(7);
  B_PUTC('$');
  for (i = 28; i >= 0; i -= 4)
    PutHex(sector >> i);
  Dump(adrEdit, topEdit - offset);
  return FUNC_NORMAL;
}
